{
****************************************************************************

        preassembler version 0.9 - written 1997 by future vision

        this preassembler is for fixup problems using tasm in combination
        with conditional assembling within the uilmdata macro file

****************************************************************************
}
{$I-}
{$N-}
{$E-}
{$D-}
{$L-}
{$Y-}

uses
  crt,
  dos;

type
  symbol=(include,equ,macro,endm,ident,reserved,ifdef,ifndef,
          scond,endif,else_,eol,eof_,record_,continue,label_,
          end_);

  fp_   =^fs_;
  fs_   =record
           name :string[90];
           pos  :longint;
           line :longint;
           last :fp_;
         end;

  mp_   =^ms_;
  ms_   =record
           name :string[40];
           used :boolean;
           pos  :longint;
           fil  :string[90];
           next :mp_;
         end;
  dp_   =^ds_;
  ds_   =record
           name :string[40];
           line :string[150];
           fil  :string[90];
           pos  :longint;
           used :boolean;
           next :dp_;
         end;
const
  fp    :fp_=(nil);
  mp    :mp_=(nil);
  dp    :dp_=(nil);

  pas   :byte=0;
  sy   :symbol=eol;

var
  fi    :file;
  fn    :string;
  s     :string;
  ss    :string;
  i     :integer;
  osy   :symbol;
  ws    :string;
  ows   :string;
  amem  :longint;
{***************************************************************************}
procedure write_mem;
begin
  writeln('original mem: ',amem:6,#10#13,
          'used mem:     ',amem-maxavail:6,#10#13,
          'free mem:     ',maxavail:6);
end;

procedure errorh(id:byte;s:string);
begin
  if id<>103 then write(#10#13'error: ');
  case id of
    100   :write('can''t open input file ',s);
    101   :write('can''t create output file ',s);
    102   :begin
             writeln('out of memory by allocating ',s,' bytes');
             write_mem;
           end;
    103   :writeln('Preassembler v0.9 - written 1997 by FUTURE VISION'#10#13,
                   '  usage : PREASM.EXE asm_file [out_file]');
  end;
  writeln;
  halt(id);
end;
{***************************************************************************}
procedure openfile;
begin
  assign(fi,fp^.name);
  reset(fi,1);
  if ioresult<>0 then errorh(100,fp^.name);
  seek(fi,fp^.pos);
  writeln;
end;

procedure newfile(fn:string);
var
  ft    :fp_;
begin
  if fp<>nil then begin
    fp^.pos:=filepos(fi);
    close(fi);
  end;
  if maxavail<sizeof(fs_) then begin
    str(sizeof(fs_),s);
    errorh(102,s);
  end;
  getmem(ft,sizeof(fs_));
  ft^.name:=fn;
  ft^.last:=fp;
  ft^.pos:=0;
  ft^.line:=0;
  fp:=ft;
  openfile;
  s:='';
end;

function lastfile:boolean;
var
  ft    :fp_;
begin
  lastfile:=false;
  close(fi);
  ft:=fp;
  if ft^.last=nil then begin
    fp^.pos:=0;
    fp^.line:=0;
    openfile;
    exit;
  end;
  fp:=ft^.last;
  freemem(ft,sizeof(fs_));
  openfile;
  lastfile:=true;
end;

function readline:boolean;
var
  inbuffer      :array[1..500] of char;
  br            :word;
begin
  readline:=false;
  if fp=nil then exit;
  while eof(fi) do if lastfile=false then exit;
  blockread(fi,inbuffer[1],150,br);
  if br=0 then exit;
  s:='';
  i:=1;
  while (inbuffer[i]<>#10) and (i<=br) do begin
    if inbuffer[i]<>#13 then s:=s+inbuffer[i];
    inc(i);
  end;
  ss:=s;
  seek(fi,filepos(fi)-br+i);
  inc(fp^.line);
  write(#13,fp^.name,' ',fp^.line:5,#13);
  readline:=true;
end;
{***************************************************************************}
procedure getsy;
  function test_cond:boolean;
  const
    condc=10;
    condd   :array[1..condc] of string[10]=(
               'IF','IF1','IF2','IFB','IFDIF',
               'IFDIFI','IFE','IFIDN','IFIDNI',
               'IFNB');
  var
    i   :integer;
  begin
    test_cond:=true;
    for i:=1 to condc do if ws=condd[i] then exit;
    test_cond:=false;
  end;

  function test_reserved:boolean;
  const
    resc=124;
    resd   :array[1..resc] of string[15]=(
              '%BIN','%CONDS','%CREF','%CREFALL',
              '%CREFREF','%CREFUREF','%CTLS','%INCL',
              '%LINUM','%LIST','%MACS','%NEWPAGE',
              '%NOCONDS','%NOCREF','%NOCTLS','%NOINCL',
              '%NOLIST','%NOMACS','%NOSYMS','%NOTRUNC',
              '%OUT','%PAGESIZE','%PCNT','%POPLCTL',
              '%PUSHLCTL','%SUBTTL','%SYMS','%TABSIZE',
              '%TEXT','%TITLE','%TRUNC','.186','.286',
              '.286C','.286P','.287','.386','.386C','.386P',
              '.387','.486','.486C','.486P','.8086','.8087',
              '.ALPHA','.CODE','.CONST','.CREF','.DATA','.DATA?',
              '.ERR','.ERR1','.ERR2','.ERRB','.ERRDEF','.ERRDIF',
              '.ERRDIFI','.ERRE','.ERRIDN','.ERRIDNI','.ERRNB',
              '.ERRNDEF','.ERRNZ','.EXIT','.FARDATA','.FARDATA?',
              '.LALL','.LFCOND','.LIST','.MODEL','.RADIX','.SALL',
              '.SEQ','.SFCOND','.STACK','.STARTUP','.TFCOND','.TYPE',
              '.XALL','.XCREF','.XLIST','??DATE','??FILENAME',
              '??TIME','??VERSION','@@32BIT','@@INTERFACE','@@OBJECT',
              '@CODE','@CODESIZE','@CPU','@CURSEG','@DATA','@DATASIZE',
              '@FARDATA','@FARDATA?','@FILENAME','@MODEL','@STARTUP',
              '@WORDSIZE','ALIGN','ALLOCATEMEMORY','LABEL','SEGMENT',
              'PROC','ENDP','ENDS','STRUC','DB','DW','DD',
              'LABEL','ASSUME','ORG','DQ','DT','DF','BYTE','WORD',
              'DWORD','FWORD','NEAR','FAR');
  var
    i   :integer;
  begin
    test_reserved:=true;
    for i:=1 to resc do if ws=resd[i] then exit;
    test_reserved:=false;
  end;

begin
  osy:=sy;
  ows:=ws;

  repeat
    if s='' then begin
      if readline then
        sy:=eol
      else
        sy:=eof_;
      exit;
    end;
    ws:='';
    while (s<>'') and (s[1] in [#9,' ']) do delete(s,1,1);
    if s<>'' then case s[1] of
      ';' :s:='';
      '=' :begin
             ws:='=';
             delete(s,1,1);
           end;
      '<' :s:='';
      else while (s<>'') and not (s[1] in [#9,' ',';','=','<']) do begin
        ws:=ws+upcase(s[1]);
        delete(s,1,1);
      end;
    end;
  until ws<>'';
  if (ws='EQU') or (ws='=') then sy:=equ
  else if ws='\' then sy:=continue
  else if ws='MACRO' then sy:=macro
  else if ws='ENDM' then sy:=endm
  else if test_reserved then sy:=reserved
  else if ws='IFDEF' then sy:=ifdef
  else if ws='IFNDEF' then sy:=ifndef
  else if test_cond then sy:=scond
  else if ws='ENDIF' then sy:=endif
  else if ws='ELSE' then sy:=else_
  else if ws='INCLUDE' then sy:=include
  else if ws='RECORD' then sy:=record_
  else if (ws[length(ws)]=':') and (osy=eol) then sy:=label_
  else if ws='END' then sy:=end_
  else sy:=ident;
end;
{***************************************************************************}
procedure next_pas(n:string);
begin
 inc(pas);
 writeln('PAS ',pas,' - ',n);
end;


procedure get_data;
var
  modify:boolean;
  ccond :integer;
  cdef  :integer;
  cmac  :integer;
  lmac  :integer;
  read_ :boolean;

  function check_def(n:string):boolean;
  var
    cp  :dp_;
  begin
  check_def:=true;
  cp:=dp;
  while cp<>nil do begin
    if cp^.name=n then exit;
    cp:=cp^.next;
  end;
  check_def:=false;
  end;

  procedure set_def(n:string);
  var
    cp  :dp_;
  begin
  cp:=dp;
  while cp<>nil do begin
    if cp^.name=n then begin
      if cp^.used=true then exit;
      cp^.used:=true;
      modify:=true;
      exit;
    end;
    cp:=cp^.next;
  end;
  end;

  function use_def(n:string):boolean;
  var
    cp  :dp_;
  begin
  use_def:=false;
  cp:=dp;
  while cp<>nil do begin
    if cp^.name=n then begin
      use_def:=cp^.used;
      exit;
    end;
    cp:=cp^.next;
  end;
  end;

  procedure add_def(n:string);
  var
    cp  :dp_;
  begin
  cp:=dp;
  if check_def(n) then exit;
  if maxavail<sizeof(ds_) then begin
    str(sizeof(ds_),s);
    errorh(102,s);
  end;
  getmem(cp,sizeof(ds_));
  cp^.next:=dp;
  cp^.name:=n;
  cp^.line:=ss;
  cp^.used:=false;
  cp^.fil:=fp^.name;
  cp^.pos:=fp^.line;
  dp:=cp;
  modify:=true;
  end;

  function check_mac(n:string):boolean;
  var
    cp  :mp_;
  begin
  check_mac:=true;
  cp:=mp;
  while cp<>nil do begin
    if cp^.name=n then exit;
    cp:=cp^.next;
  end;
  check_mac:=false;
  end;

  procedure add_mac(n:string);
  var
    cp  :mp_;
  begin
  if check_mac(n) then exit;
  if maxavail<sizeof(ms_) then begin
    str(sizeof(fs_),s);
    errorh(102,s);
  end;
  getmem(cp,sizeof(ms_));
  cp^.next:=mp;
  cp^.name:=n;
  cp^.used:=false;
  mp:=cp;
  modify:=true;
  end;

  function use_mac(n:string):boolean;
  var
    cp  :mp_;
  begin
  cp:=mp;
  use_mac:=false;
  while cp<>nil do begin
    if cp^.name=n then begin
      use_mac:=cp^.used;
      exit;
    end;
    cp:=cp^.next;
  end;
  end;

  procedure set_mac(n:string);
  var
    cp  :mp_;
  begin
  cp:=mp;
  while cp<>nil do begin
    if cp^.name=n then begin
      if cp^.used=true then exit;
      cp^.used:=true;
      cp^.pos:=fp^.line;
      cp^.fil:=fp^.name;
      modify:=true;
      exit;
    end;
    cp:=cp^.next;
  end;
  end;

begin
  repeat
    modify:=false;
    ccond:=0;
    cdef:=0;
    cmac:=0;
    lmac:=0;
    getsy;
    next_pas('GENERATING DATA LIST');
    while sy<>eof_ do begin
      read_:=true;
      if (osy=eol) and (pos('call_rm2hi',s)>0) then begin
        osy:=osy;
      end;
      case sy of
       record_:begin
                    repeat
                      getsy;
                    until (sy=eof_) or ((sy=eol) and (osy<>continue));
       end;
       include:if (ccond=0) and (lmac=cdef) then begin
                 getsy;
                 newfile(ws);
               end;
        scond,
        ifndef:inc(ccond);
        endif :begin
                 if ccond>0 then dec(ccond) else begin
                   dec(cdef);
                   if cdef<lmac then dec(lmac);
                 end;
                 if cdef<0 then errorh(104,'');
               end;
        ifdef :if ccond>0 then inc(ccond) else begin
                 inc(cdef);
                 getsy;
                 if (sy=ident) and (check_def(ws)) then begin
                   set_def(ws);
                   if use_def(ws) and (lmac=cdef-1) then
                     lmac:=cdef;
                 end;
               end;
        else_ :if (ccond=0) and (lmac=cdef-1) then inc(lmac);
        equ   :if (lmac=cdef) and (osy=ident) then add_def(ows);
        macro :if (lmac=cdef) and (osy=ident) then begin
                 add_mac(ows);
                 if not use_mac(ows) then
                   while (sy<>eof_) and (sy<>endm) do
                     getsy;
               end;
        ident :if ((osy=eol) or (osy=label_)) and check_mac(ws) and
                 (lmac=cdef) then begin
                 getsy;
                 read_:=false;
                 if sy in [ident,eol,eof_,reserved] then
                   set_mac(ows);
               end;
        end_  :begin
                 while lastfile do;
                 read_:=false;
                 sy:=eof_;
               end;
      end;
      if read_ then getsy;
    end;
  until modify=false;
end;
{***************************************************************************}
procedure save_data;
var
  fo    :text;
  cp    :dp_;
  cmp   :mp_;
begin
  next_pas('SAVING DATA');
  assign(fo,fn);
  rewrite(fo);
  if ioresult<>0 then errorh(101,fn);
  writeln('effective definitions:');
  cp:=dp;
  while cp<>nil do begin
    if cp^.used then begin
      writeln(fo,cp^.line);
      write(cp^.name);
      gotoxy(30,wherey);
      write(':',cp^.fil);
      gotoxy(50,wherey);
      clreol;
      writeln(':',cp^.pos:6);
    end;
    cp:=cp^.next;
  end;
  writeln('used macros:');
  cmp:=mp;
  while cmp<>nil do begin
    if cmp^.used then begin
      write(cmp^.name);
      gotoxy(30,wherey);
      write(':',cmp^.fil);
      gotoxy(50,wherey);
      clreol;
      writeln(':',cmp^.pos:6);
    end;
    cmp:=cmp^.next;
  end;
  close(fo);
end;
{***************************************************************************}
begin
if not (paramcount in [1,2]) then errorh(103,'');

amem:=maxavail;

fn:=paramstr(1);

for i:=1 to length(fn) do fn[i]:=upcase(fn[i]);
if copy(fn,length(fn)-3,4)='.ASM' then delete(fn,length(fn)-3,4);


newfile(fn+'.ASM');
get_data;
if paramcount=2 then begin
  fn:=paramstr(2);
  for i:=1 to length(fn) do fn[i]:=upcase(fn[i]);
end else
  fn:='UILMDATA.DEF';
save_data;
writeln('memory overview:');
write_mem;
end.
